using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace UltraWinGrid_Extended_Selection_With_No_CTRL_Key
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private Infragistics.Win.Misc.UltraLabel ultraLabel1;
		private Infragistics.Win.UltraWinGrid.UltraGrid ultraGrid1;

		#region Windows Form Designer generated code



		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ultraGrid1 = new Infragistics.Win.UltraWinGrid.UltraGrid();
			this.ultraLabel1 = new Infragistics.Win.Misc.UltraLabel();
			((System.ComponentModel.ISupportInitialize)(this.ultraGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// ultraGrid1
			// 
			this.ultraGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.ultraGrid1.Location = new System.Drawing.Point(8, 48);
			this.ultraGrid1.Name = "ultraGrid1";
			this.ultraGrid1.Size = new System.Drawing.Size(560, 208);
			this.ultraGrid1.TabIndex = 4;
			this.ultraGrid1.Text = "ultraGrid1";
			this.ultraGrid1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.ultraGrid1_MouseUp);
			// 
			// ultraLabel1
			// 
			this.ultraLabel1.Location = new System.Drawing.Point(8, 8);
			this.ultraLabel1.Name = "ultraLabel1";
			this.ultraLabel1.Size = new System.Drawing.Size(560, 32);
			this.ultraLabel1.TabIndex = 5;
			this.ultraLabel1.Text = "Select or deselect rows in the grid by clicking the Row Selectors. You do not nee" +
				"d to hold down the CTRL key.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(576, 270);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.ultraLabel1,
																		  this.ultraGrid1});
			this.Name = "Form1";
			this.Text = "UltraWinGrid Extended Selection With No CTRL Key CS";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.ultraGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private DataTable dt1;

		#region Form1_Load

		private void Form1_Load(object sender, System.EventArgs e)		
		{	
			dt1 = DummyDataCreator.GetData();			
			this.ultraGrid1.DataSource = dt1;  

			// Create a new SelectionStrategyNone. This selection Strategy basically does nothing.
			SelectionStrategyNone selectionStrategyNone = new SelectionStrategyNone(this.ultraGrid1);

			// Set teh SelectionStrategyFilter on the grid and pass in the selectionStrategyNone.
			this.ultraGrid1.SelectionStrategyFilter = new SelectionStrategyFilter_NoRowSelection(selectionStrategyNone);

            this.ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.RowSelect;
		}

		#endregion Form1_Load

		#region ultraGrid1_MouseUp

		private void ultraGrid1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			UltraGrid grid = sender as UltraGrid;

			// Get the row that was clicked on, if any.
			UltraGridRow row = this.GetRowFromPoint(grid, new Point(e.X, e.Y));
						
			if (row != null)
			{
				// Clear any cell or column selection. 
				grid.Selected.Cells.Clear();
				grid.Selected.Columns.Clear();				

				// Toggle the selection of the row. 
				row.Selected = ! row.Selected;				
			}			
		}

		#endregion ultraGrid1_MouseUp

		#region GetRowFromPoint

		private UltraGridRow GetRowFromPoint(UltraGrid grid, Point p)
		{
			//Get the last element that the mouse entered
			UIElement elementFromPoint = grid.DisplayLayout.UIElement.ElementFromPoint(p);
    
			//See if there's a RowUIElement in the chain.
			RowUIElement rowElement;
			if ( elementFromPoint is RowUIElement )
				rowElement = (RowUIElement)elementFromPoint;
			else
			{
				rowElement = (RowUIElement)elementFromPoint.GetAncestor(typeof(RowUIElement));
			}
    
			if (rowElement == null) 
				return null;

			//Try to get a row from the element
			UltraGridRow row = (UltraGridRow)rowElement.GetContext(typeof(UltraGridRow));

			//If no row was returned, then the mouse is not over a row. 
			if ( row == null )
				return null;
    
			//The mouse is over a row. 
			return row;
		}

		#endregion GetRowFromPoint

		#region SelectionStrategyFilter_NoRowSelection class

		public class SelectionStrategyFilter_NoRowSelection: ISelectionStrategyFilter
		{			
			private SelectionStrategyBase selectionStrategy = null;

			public SelectionStrategyFilter_NoRowSelection(SelectionStrategyBase selectionStrategy)
			{
				// Store the selectionStrategy that was passed in.
				this.selectionStrategy = selectionStrategy;
			}

			#region Implementation of ISelectionStrategyFilter
			public Infragistics.Win.ISelectionStrategy GetSelectionStrategy(Infragistics.Shared.ISelectableItem item)
			{
				// If the item is an UltraGridRow, then pass back SelectionStrategyNone. 
				// This means the grid will not do any automatic selecting of rows. 
				if (item is UltraGridRow)
					return this.selectionStrategy;

				// For any other type, pass back null. This means that for 
				// anything other than a row (such as a column or cell)
				// the grid will use it's normal default selection strategy. 
				return null;				
			}		
			#endregion
		}

		#endregion // SelectionStrategyFilter_NoRowSelection class		
	}
}




